diff -rN -u old-otp-0804-1/erts/configure new-otp-0804/erts/configure
--- old-otp-0804-1/erts/configure	2006-08-22 23:25:17.000000000 +0100
+++ new-otp-0804/erts/configure	2006-08-22 23:25:22.000000000 +0100
@@ -6859,7 +6859,7 @@
 volatile int erl_fp_exception;
 
 /* Is there no standard identifier for Darwin/MacOSX ? */
-#if defined(__ppc__) && defined(__APPLE__) && defined(__MACH__) && !defined(__DARWIN__)
+#if defined(__APPLE__) && defined(__MACH__) && !defined(__DARWIN__)
 #define __DARWIN__ 1
 #endif
 
@@ -6881,7 +6881,7 @@
     __asm__ __volatile__("ldmxcsr %0" : : "m"(mxcsr));
 }
 
-#if defined(__x86_64__)
+#if defined(__x86_64__) || defined(__DARWIN__)
 static inline int cpu_has_sse2(void) { return 1; }
 #else /* !__x86_64__ */
 /*
@@ -7154,6 +7154,11 @@
     regs[PT_NIP] += 4;
     regs[PT_FPSCR] = 0x80|0x40|0x10;	/* VE, OE, ZE; not UE or XE */
 #endif
+#elif defined(__DARWIN__) && defined(__i386__)
+    mcontext_t mc = uc->uc_mcontext;
+    i386_float_state_t fpstate = mc->fs;
+    fpstate.fpu_mxcsr = 0x1F80;
+    *((unsigned short *)&fpstate.fpu_fsw) &= ~0xFF;
 #elif defined(__DARWIN__)
     mcontext_t mc = uc->uc_mcontext;
     mc->ss.srr0 += 4;
diff -rN -u old-otp-0804-1/erts/configure.in new-otp-0804/erts/configure.in
--- old-otp-0804-1/erts/configure.in	2006-08-22 23:25:17.000000000 +0100
+++ new-otp-0804/erts/configure.in	2006-08-22 23:25:22.000000000 +0100
@@ -1490,7 +1490,7 @@
 volatile int erl_fp_exception;
 
 /* Is there no standard identifier for Darwin/MacOSX ? */
-#if defined(__ppc__) && defined(__APPLE__) && defined(__MACH__) && !defined(__DARWIN__)
+#if defined(__APPLE__) && defined(__MACH__) && !defined(__DARWIN__)
 #define __DARWIN__ 1
 #endif
 
@@ -1512,7 +1512,7 @@
     __asm__ __volatile__("ldmxcsr %0" : : "m"(mxcsr));
 }
 
-#if defined(__x86_64__)
+#if defined(__x86_64__) || defined(__DARWIN__)
 static inline int cpu_has_sse2(void) { return 1; }
 #else /* !__x86_64__ */
 /*
@@ -1785,6 +1785,11 @@
     regs[PT_NIP] += 4;
     regs[PT_FPSCR] = 0x80|0x40|0x10;	/* VE, OE, ZE; not UE or XE */
 #endif
+#elif defined(__DARWIN__) && defined(__i386__)
+    mcontext_t mc = uc->uc_mcontext;
+    i386_float_state_t fpstate = mc->fs;
+    fpstate.fpu_mxcsr = 0x1F80;
+    *((unsigned short *)&fpstate.fpu_fsw) &= ~0xFF;
 #elif defined(__DARWIN__)
     mcontext_t mc = uc->uc_mcontext;
     mc->ss.srr0 += 4;
@@ -1848,6 +1853,7 @@
     do_fmul();
     return do_check();
 }
+
 ], erl_ok=reliable, erl_ok=unreliable, erl_ok=unreliable)
 if test $erl_ok = unreliable; then
     AC_DEFINE(NO_FPE_SIGNALS)
diff -rN -u old-otp-0804-1/erts/emulator/Makefile.in new-otp-0804/erts/emulator/Makefile.in
--- old-otp-0804-1/erts/emulator/Makefile.in	2006-08-22 23:25:17.000000000 +0100
+++ new-otp-0804/erts/emulator/Makefile.in	2006-08-22 23:25:23.000000000 +0100
@@ -705,7 +705,7 @@
 		$(OBJDIR)/erl_mtrace_sys_wrap.o
 
 HIPE_ultrasparc_OBJS=$(OBJDIR)/hipe_sparc.o $(OBJDIR)/hipe_sparc_glue.o $(OBJDIR)/hipe_sparc_bifs.o $(OBJDIR)/hipe_sparc_stack.o
-HIPE_x86_OBJS=$(OBJDIR)/hipe_x86.o $(OBJDIR)/hipe_x86_glue.o $(OBJDIR)/hipe_x86_bifs.o $(OBJDIR)/hipe_x86_signal.o $(OBJDIR)/hipe_x86_stack.o
+HIPE_x86_OBJS=$(OBJDIR)/hipe_x86.o $(OBJDIR)/hipe_x86_glue.o $(OBJDIR)/hipe_x86_bifs.o $(OBJDIR)/hipe_x86_signal.o $(OBJDIR)/hipe_x86_stack.o $(OBJDIR)/mach_override.o
 HIPE_amd64_OBJS=$(OBJDIR)/hipe_amd64.o $(OBJDIR)/hipe_amd64_glue.o $(OBJDIR)/hipe_amd64_bifs.o $(OBJDIR)/hipe_x86_signal.o $(OBJDIR)/hipe_x86_stack.o
 HIPE_ppc_OBJS=$(OBJDIR)/hipe_ppc.o $(OBJDIR)/hipe_ppc_glue.o $(OBJDIR)/hipe_ppc_bifs.o $(OBJDIR)/hipe_ppc_stack.o
 HIPE_ppc64_OBJS=$(HIPE_ppc_OBJS)
diff -rN -u old-otp-0804-1/erts/emulator/hipe/hipe_x86.c new-otp-0804/erts/emulator/hipe/hipe_x86.c
--- old-otp-0804-1/erts/emulator/hipe/hipe_x86.c	2006-08-22 23:25:17.000000000 +0100
+++ new-otp-0804/erts/emulator/hipe/hipe_x86.c	2006-08-22 23:25:23.000000000 +0100
@@ -15,6 +15,11 @@
 #undef ERL_FUN_SIZE
 #include "hipe_literals.h"
 
+/* Is there no standard identifier for Darwin/MacOSX ? */
+#if defined(__APPLE__) && defined(__MACH__) && !defined(__DARWIN__)
+#define __DARWIN__ 1
+#endif
+
 void hipe_patch_load_fe(Uint32 *address, Uint32 value)
 {
     /* address points to a disp32 or imm32 operand */
@@ -107,7 +112,12 @@
 	abort();
     map_start = mmap(map_hint, map_bytes,
 		     PROT_EXEC|PROT_READ|PROT_WRITE,
-		     MAP_PRIVATE|MAP_ANONYMOUS
+		     MAP_PRIVATE
+#ifndef __DARWIN__
+         |MAP_ANONYMOUS
+#else
+         |MAP_ANON
+#endif 
 #ifdef __x86_64__
 		     |MAP_32BIT
 #endif
diff -rN -u old-otp-0804-1/erts/emulator/hipe/hipe_x86_asm.m4 new-otp-0804/erts/emulator/hipe/hipe_x86_asm.m4
--- old-otp-0804-1/erts/emulator/hipe/hipe_x86_asm.m4	2006-08-22 23:25:17.000000000 +0100
+++ new-otp-0804/erts/emulator/hipe/hipe_x86_asm.m4	2006-08-22 23:25:23.000000000 +0100
@@ -17,6 +17,28 @@
 `#define LEAF_WORDS	'LEAF_WORDS
 
 /*
+ * Workarounds for Darwin.
+ */
+ifelse(OPSYS,darwin,``
+/* Darwin */
+#define TEXT        .text
+#define JOIN(X,Y)       X##Y
+#define CSYM(NAME)      JOIN(_,NAME)
+#define ASYM(NAME)      CSYM(NAME)
+#define GLOBAL(NAME)	.globl NAME
+#define SET_SIZE(NAME)	/*empty*/
+#define TYPE_FUNCTION(NAME)	/*empty*/
+'',``
+/* Not Darwin */
+#define TEXT        .section ".text"
+#define CSYM(NAME)  NAME
+#define ASYM(NAME)  NAME
+#define GLOBAL(NAME)	.globl NAME
+#define SET_SIZE(NAME)	.size NAME,.-NAME
+#define TYPE_FUNCTION(NAME)	.type NAME,@function
+'')dnl
+
+/*
  * Reserved registers.
  */
 `#define P	%ebp'
diff -rN -u old-otp-0804-1/erts/emulator/hipe/hipe_x86_bifs.m4 new-otp-0804/erts/emulator/hipe/hipe_x86_bifs.m4
--- old-otp-0804-1/erts/emulator/hipe/hipe_x86_bifs.m4	2006-08-22 23:25:17.000000000 +0100
+++ new-otp-0804/erts/emulator/hipe/hipe_x86_bifs.m4	2006-08-22 23:25:23.000000000 +0100
@@ -38,10 +38,10 @@
 `
 #ifndef HAVE_$1
 #`define' HAVE_$1
-	.section ".text"
+	TEXT
 	.align	4
-	.global	$1
-$1:
+	GLOBAL(ASYM($1))
+ASYM($1):
 	/* copy native stack pointer */
 	NBIF_COPY_NSP(1)
 
@@ -51,7 +51,7 @@
 	/* make the call on the C stack */
 	NBIF_ARG_REG(0,P)
 	NBIF_ARG(1,1,0)
-	call	$2
+	call CSYM($2)
 
 	/* switch to native stack */
 	SWITCH_C_TO_ERLANG
@@ -60,18 +60,18 @@
 	TEST_GOT_EXN
 	jz	nbif_1_simple_exception
 	NBIF_RET(1)
-	.size	$1,.-$1
-	.type	$1,@function
+	SET_SIZE(ASYM($1))
+	TYPE_FUNCTION(ASYM($1))
 #endif')
 
 define(standard_bif_interface_2,
 `
 #ifndef HAVE_$1
 #`define' HAVE_$1
-	.section ".text"
+	TEXT
 	.align	4
-	.global	$1
-$1:
+	GLOBAL(ASYM($1))
+ASYM($1):
 	/* copy native stack pointer */
 	NBIF_COPY_NSP(2)
 
@@ -82,7 +82,7 @@
 	NBIF_ARG_REG(0,P)
 	NBIF_ARG(1,2,0)
 	NBIF_ARG(2,2,1)
-	call	$2
+	call CSYM($2)
 
 	/* switch to native stack */
 	SWITCH_C_TO_ERLANG
@@ -91,18 +91,18 @@
 	TEST_GOT_EXN
 	jz	nbif_2_simple_exception
 	NBIF_RET(2)
-	.size	$1,.-$1
-	.type	$1,@function
+	SET_SIZE(ASYM($1))
+	TYPE_FUNCTION(ASYM($1))
 #endif')
 
 define(standard_bif_interface_3,
 `
 #ifndef HAVE_$1
 #`define' HAVE_$1
-	.section ".text"
+	TEXT
 	.align	4
-	.global	$1
-$1:
+	GLOBAL(ASYM($1))
+ASYM($1):
 	/* copy native stack pointer */
 	NBIF_COPY_NSP(3)
 
@@ -114,7 +114,7 @@
 	NBIF_ARG(1,3,0)
 	NBIF_ARG(2,3,1)
 	NBIF_ARG(3,3,2)
-	call	$2
+	call CSYM($2)
 
 	/* switch to native stack */
 	SWITCH_C_TO_ERLANG
@@ -123,8 +123,8 @@
 	TEST_GOT_EXN
 	jz	nbif_3_simple_exception
 	NBIF_RET(3)
-	.size	$1,.-$1
-	.type	$1,@function
+	SET_SIZE(ASYM($1))
+	TYPE_FUNCTION(ASYM($1))
 #endif')
 
 /*
@@ -138,10 +138,10 @@
 `
 #ifndef HAVE_$1
 #`define' HAVE_$1
-	.section ".text"
+	TEXT
 	.align	4
-	.global	$1
-$1:
+	GLOBAL(ASYM($1))
+ASYM($1):
 	/* copy native stack pointer */
 	NBIF_COPY_NSP(1)
 
@@ -154,7 +154,7 @@
 	/* make the call on the C stack */
 	NBIF_ARG_REG(0,P)
 	NBIF_ARG(1,1,0)
-	call	$2
+	call CSYM($2)
 
 	/* switch to native stack */
 	SWITCH_C_TO_ERLANG
@@ -164,20 +164,20 @@
 	jz	1f
 	NBIF_RET(1)
 1:
-	movl	`$'$1, %edx	/* resumption address */
+	movl	`$'ASYM($1), %edx	/* resumption address */
 	jmp	nbif_1_hairy_exception
-	.size	$1,.-$1
-	.type	$1,@function
+	SET_SIZE(ASYM($1))
+	TYPE_FUNCTION(ASYM($1))
 #endif')
 
 define(expensive_bif_interface_2,
 `
 #ifndef HAVE_$1
 #`define' HAVE_$1
-	.section ".text"
+	TEXT
 	.align	4
-	.global	$1
-$1:
+	GLOBAL(ASYM($1))
+ASYM($1):
 	/* copy native stack pointer */
 	NBIF_COPY_NSP(2)
 
@@ -191,7 +191,7 @@
 	NBIF_ARG_REG(0,P)
 	NBIF_ARG(1,2,0)
 	NBIF_ARG(2,2,1)
-	call	$2
+	call CSYM($2)
 
 	/* switch to native stack */
 	SWITCH_C_TO_ERLANG
@@ -201,10 +201,10 @@
 	jz	1f
 	NBIF_RET(2)
 1:
-	movl	`$'$1, %edx	/* resumption address */
+	movl	`$'ASYM($1), %edx	/* resumption address */
 	jmp	nbif_2_hairy_exception
-	.size	$1,.-$1
-	.type	$1,@function
+	SET_SIZE(ASYM($1))
+	TYPE_FUNCTION(ASYM($1))
 #endif')
 
 /*
@@ -221,34 +221,34 @@
 `
 #ifndef HAVE_$1
 #`define' HAVE_$1
-	.section ".text"
+	TEXT
 	.align	4
-	.global	$1
-$1:
+	GLOBAL(ASYM($1))
+ASYM($1):
 	/* switch to C stack */
 	SWITCH_ERLANG_TO_C
 
 	/* make the call on the C stack */
 	NBIF_ARG_REG(0,P)
-	call	$2
+	call CSYM($2)
 
 	/* switch to native stack */
 	SWITCH_C_TO_ERLANG
 
 	/* return */
 	NBIF_RET(0)
-	.size	$1,.-$1
-	.type	$1,@function
+	SET_SIZE(ASYM($1))
+	TYPE_FUNCTION(ASYM($1))
 #endif')
 
 define(nofail_primop_interface_1,
 `
 #ifndef HAVE_$1
 #`define' HAVE_$1
-	.section ".text"
+	TEXT
 	.align	4
-	.global	$1
-$1:
+	GLOBAL(ASYM($1))
+ASYM($1):
 	/* copy native stack pointer */
 	NBIF_COPY_NSP(1)
 
@@ -258,25 +258,25 @@
 	/* make the call on the C stack */
 	NBIF_ARG_REG(0,P)
 	NBIF_ARG(1,1,0)
-	call	$2
+	call CSYM($2)
 
 	/* switch to native stack */
 	SWITCH_C_TO_ERLANG
 
 	/* return */
 	NBIF_RET(1)
-	.size	$1,.-$1
-	.type	$1,@function
+	SET_SIZE(ASYM($1))
+	TYPE_FUNCTION(ASYM($1))
 #endif')
 
 define(nofail_primop_interface_2,
 `
 #ifndef HAVE_$1
 #`define' HAVE_$1
-	.section ".text"
+	TEXT
 	.align	4
-	.global	$1
-$1:
+	GLOBAL(ASYM($1))
+ASYM($1):
 	/* copy native stack pointer */
 	NBIF_COPY_NSP(2)
 
@@ -287,25 +287,25 @@
 	NBIF_ARG_REG(0,P)
 	NBIF_ARG(1,2,0)
 	NBIF_ARG(2,2,1)
-	call	$2
+	call CSYM($2)
 
 	/* switch to native stack */
 	SWITCH_C_TO_ERLANG
 
 	/* return */
 	NBIF_RET(2)
-	.size	$1,.-$1
-	.type	$1,@function
+	SET_SIZE(ASYM($1))
+	TYPE_FUNCTION(ASYM($1))
 #endif')
 
 define(nofail_primop_interface_3,
 `
 #ifndef HAVE_$1
 #`define' HAVE_$1
-	.section ".text"
+	TEXT
 	.align	4
-	.global	$1
-$1:
+	GLOBAL(ASYM($1))
+ASYM($1):
 	/* copy native stack pointer */
 	NBIF_COPY_NSP(3)
 
@@ -317,15 +317,15 @@
 	NBIF_ARG(1,3,0)
 	NBIF_ARG(2,3,1)
 	NBIF_ARG(3,3,2)
-	call	$2
+	call CSYM($2)
 
 	/* switch to native stack */
 	SWITCH_C_TO_ERLANG
 
 	/* return */
 	NBIF_RET(3)
-	.size	$1,.-$1
-	.type	$1,@function
+	SET_SIZE(ASYM($1))
+	TYPE_FUNCTION(ASYM($1))
 #endif')
 
 /*
@@ -343,34 +343,34 @@
 `
 #ifndef HAVE_$1
 #`define' HAVE_$1
-	.section ".text"
+	TEXT
 	.align	4
-	.global	$1
-$1:
+	GLOBAL(ASYM($1))
+ASYM($1):
 	/* switch to C stack */
 	SWITCH_ERLANG_TO_C_QUICK
 
 	/* make the call on the C stack */
 	NBIF_ARG_REG(0,P)
-	call	$2
+	call CSYM($2)
 
 	/* switch to native stack */
 	SWITCH_C_TO_ERLANG_QUICK
 
 	/* return */
 	NBIF_RET(0)
-	.size	$1,.-$1
-	.type	$1,@function
+	SET_SIZE(ASYM($1))
+	TYPE_FUNCTION(ASYM($1))
 #endif')
 
 define(nocons_nofail_primop_interface_1,
 `
 #ifndef HAVE_$1
 #`define' HAVE_$1
-	.section ".text"
+	TEXT
 	.align	4
-	.global	$1
-$1:
+	GLOBAL(ASYM($1))
+ASYM($1):
 	/* copy native stack pointer */
 	NBIF_COPY_NSP(1)
 
@@ -380,25 +380,25 @@
 	/* make the call on the C stack */
 	NBIF_ARG_REG(0,P)
 	NBIF_ARG(1,1,0)
-	call	$2
+	call CSYM($2)
 
 	/* switch to native stack */
 	SWITCH_C_TO_ERLANG_QUICK
 
 	/* return */
 	NBIF_RET(1)
-	.size	$1,.-$1
-	.type	$1,@function
+	SET_SIZE(ASYM($1))
+	TYPE_FUNCTION(ASYM($1))
 #endif')
 
 define(nocons_nofail_primop_interface_2,
 `
 #ifndef HAVE_$1
 #`define' HAVE_$1
-	.section ".text"
+	TEXT
 	.align	4
-	.global	$1
-$1:
+	GLOBAL(ASYM($1))
+ASYM($1):
 	/* copy native stack pointer */
 	NBIF_COPY_NSP(2)
 
@@ -409,25 +409,25 @@
 	NBIF_ARG_REG(0,P)
 	NBIF_ARG(1,2,0)
 	NBIF_ARG(2,2,1)
-	call	$2
+	call CSYM($2)
 
 	/* switch to native stack */
 	SWITCH_C_TO_ERLANG_QUICK
 
 	/* return */
 	NBIF_RET(2)
-	.size	$1,.-$1
-	.type	$1,@function
+	SET_SIZE(ASYM($1))
+	TYPE_FUNCTION(ASYM($1))
 #endif')
 
 define(nocons_nofail_primop_interface_3,
 `
 #ifndef HAVE_$1
 #`define' HAVE_$1
-	.section ".text"
+	TEXT
 	.align	4
-	.global	$1
-$1:
+	GLOBAL(ASYM($1))
+ASYM($1):
 	/* copy native stack pointer */
 	NBIF_COPY_NSP(3)
 
@@ -439,25 +439,25 @@
 	NBIF_ARG(1,3,0)
 	NBIF_ARG(2,3,1)
 	NBIF_ARG(3,3,2)
-	call	$2
+	call CSYM($2)
 
 	/* switch to native stack */
 	SWITCH_C_TO_ERLANG_QUICK
 
 	/* return */
 	NBIF_RET(3)
-	.size	$1,.-$1
-	.type	$1,@function
+	SET_SIZE(ASYM($1))
+	TYPE_FUNCTION(ASYM($1))
 #endif')
 
 define(nocons_nofail_primop_interface_5,
 `
 #ifndef HAVE_$1
 #`define' HAVE_$1
-	.section ".text"
+	TEXT
 	.align	4
-	.global	$1
-$1:
+	GLOBAL(ASYM($1))
+ASYM($1):
 	/* copy native stack pointer */
 	NBIF_COPY_NSP(5)
 
@@ -471,15 +471,15 @@
 	NBIF_ARG(3,5,2)
 	NBIF_ARG(4,5,3)
 	NBIF_ARG(5,5,4)
-	call	$2
+	call CSYM($2)
 
 	/* switch to native stack */
 	SWITCH_C_TO_ERLANG_QUICK
 
 	/* return */
 	NBIF_RET(5)
-	.size	$1,.-$1
-	.type	$1,@function
+	SET_SIZE(ASYM($1))
+	TYPE_FUNCTION(ASYM($1))
 #endif')
 
 /*
@@ -497,33 +497,33 @@
 `
 #ifndef HAVE_$1
 #`define' HAVE_$1
-	.section ".text"
+	TEXT
 	.align	4
-	.global	$1
-$1:
+	GLOBAL(ASYM($1))
+ASYM($1):
 	/* switch to C stack */
 	SWITCH_ERLANG_TO_C_QUICK
 
 	/* make the call on the C stack */
-	call	$2
+	call CSYM($2)
 
 	/* switch to native stack */
 	SWITCH_C_TO_ERLANG_QUICK
 
 	/* return */
 	NBIF_RET(0)
-	.size	$1,.-$1
-	.type	$1,@function
+	SET_SIZE(ASYM($1))
+	TYPE_FUNCTION(ASYM($1))
 #endif')
 
 define(noproc_primop_interface_1,
 `
 #ifndef HAVE_$1
 #`define' HAVE_$1
-	.section ".text"
+	TEXT
 	.align	4
-	.global	$1
-$1:
+	GLOBAL(ASYM($1))
+ASYM($1):
 	/* copy native stack pointer */
 	NBIF_COPY_NSP(1)
 
@@ -532,25 +532,25 @@
 
 	/* make the call on the C stack */
 	NBIF_ARG(0,1,0)
-	call	$2
+	call CSYM($2)
 
 	/* switch to native stack */
 	SWITCH_C_TO_ERLANG_QUICK
 
 	/* return */
 	NBIF_RET(1)
-	.size	$1,.-$1
-	.type	$1,@function
+	SET_SIZE(ASYM($1))
+	TYPE_FUNCTION(ASYM($1))
 #endif')
 
 define(noproc_primop_interface_2,
 `
 #ifndef HAVE_$1
 #`define' HAVE_$1
-	.section ".text"
+	TEXT
 	.align	4
-	.global	$1
-$1:
+	GLOBAL(ASYM($1))
+ASYM($1):
 	/* copy native stack pointer */
 	NBIF_COPY_NSP(2)
 
@@ -560,25 +560,25 @@
 	/* make the call on the C stack */
 	NBIF_ARG(0,2,0)
 	NBIF_ARG(1,2,1)
-	call	$2
+	call CSYM($2)
 
 	/* switch to native stack */
 	SWITCH_C_TO_ERLANG_QUICK
 
 	/* return */
 	NBIF_RET(2)
-	.size	$1,.-$1
-	.type	$1,@function
+	SET_SIZE(ASYM($1))
+	TYPE_FUNCTION(ASYM($1))
 #endif')
 
 define(noproc_primop_interface_3,
 `
 #ifndef HAVE_$1
 #`define' HAVE_$1
-	.section ".text"
+	TEXT
 	.align	4
-	.global	$1
-$1:
+	GLOBAL(ASYM($1))
+ASYM($1):
 	/* copy native stack pointer */
 	NBIF_COPY_NSP(3)
 
@@ -589,25 +589,25 @@
 	NBIF_ARG(0,3,0)
 	NBIF_ARG(1,3,1)
 	NBIF_ARG(2,3,2)
-	call	$2
+	call CSYM($2)
 
 	/* switch to native stack */
 	SWITCH_C_TO_ERLANG_QUICK
 
 	/* return */
 	NBIF_RET(3)
-	.size	$1,.-$1
-	.type	$1,@function
+	SET_SIZE(ASYM($1))
+	TYPE_FUNCTION(ASYM($1))
 #endif')
 
 define(noproc_primop_interface_5,
 `
 #ifndef HAVE_$1
 #`define' HAVE_$1
-	.section ".text"
+	TEXT
 	.align	4
-	.global	$1
-$1:
+	GLOBAL(ASYM($1))
+ASYM($1):
 	/* copy native stack pointer */
 	NBIF_COPY_NSP(5)
 
@@ -620,15 +620,15 @@
 	NBIF_ARG(2,5,2)
 	NBIF_ARG(3,5,3)
 	NBIF_ARG(4,5,4)
-	call	$2
+	call CSYM($2)
 
 	/* switch to native stack */
 	SWITCH_C_TO_ERLANG_QUICK
 
 	/* return */
 	NBIF_RET(5)
-	.size	$1,.-$1
-	.type	$1,@function
+	SET_SIZE(ASYM($1))
+	TYPE_FUNCTION(ASYM($1))
 #endif')
 
 /*
diff -rN -u old-otp-0804-1/erts/emulator/hipe/hipe_x86_glue.S new-otp-0804/erts/emulator/hipe/hipe_x86_glue.S
--- old-otp-0804-1/erts/emulator/hipe/hipe_x86_glue.S	2006-08-22 23:25:17.000000000 +0100
+++ new-otp-0804/erts/emulator/hipe/hipe_x86_glue.S	2006-08-22 23:25:23.000000000 +0100
@@ -34,16 +34,16 @@
 	/* switch to native stack */	\
 	SWITCH_C_TO_ERLANG
 
-	.section ".text"
+	TEXT
 
 /*
  * int x86_call_to_native(Process *p);
  * Emulated code recursively calls native code.
  */
 	.align	4
-	.global	x86_call_to_native
-	.global	nbif_return
-x86_call_to_native:
+	GLOBAL(CSYM(x86_call_to_native))
+	GLOBAL(ASYM(nbif_return))
+CSYM(x86_call_to_native):
 	ENTER_FROM_C
 	/* get argument registers */
 	LOAD_ARG_REGS
@@ -55,7 +55,7 @@
  *
  * This is where native code returns to emulated code.
  */
-nbif_return:
+ASYM(nbif_return):
 	movl	%eax, P_ARG0(P)			# save retval
 	movl	$HIPE_MODE_SWITCH_RES_RETURN, %eax
 /* FALLTHROUGH to .flush_exit
@@ -94,8 +94,8 @@
  * XXX: Different stubs for different number of register parameters?
  */
 	.align	4
-	.global	nbif_callemu
-nbif_callemu:
+	GLOBAL(ASYM(nbif_callemu))
+ASYM(nbif_callemu):
 	STORE_ARG_REGS
 	movl	$HIPE_MODE_SWITCH_RES_CALL, %eax
 	jmp	.suspend_exit
@@ -104,8 +104,8 @@
  * nbif_apply
  */
 	.align	4
-	.global	nbif_apply
-nbif_apply:
+	GLOBAL(ASYM(nbif_apply))
+ASYM(nbif_apply):
 	STORE_ARG_REGS
 	movl	$HIPE_MODE_SWITCH_RES_APPLY, %eax
 	jmp	.suspend_exit
@@ -121,8 +121,8 @@
  */
 #if X86_NR_ARG_REGS == 5
 	.align	4
-	.global nbif_ccallemu5
-nbif_ccallemu5:
+	GLOBAL(ASYM(nbif_ccallemu5))
+ASYM(nbif_ccallemu5):
 	movl	ARG4, P_ARG4(P)
 	movl	4(NSP), ARG4
 	/*FALLTHROUGH*/
@@ -130,8 +130,8 @@
 
 #if X86_NR_ARG_REGS >= 4
 	.align	4
-	.global nbif_ccallemu4
-nbif_ccallemu4:
+	GLOBAL(ASYM(nbif_ccallemu4))
+ASYM(nbif_ccallemu4):
 	movl	ARG3, P_ARG3(P)
 #if X86_NR_ARG_REGS > 4
 	movl	ARG4, ARG3
@@ -143,8 +143,8 @@
 
 #if X86_NR_ARG_REGS >= 3
 	.align	4
-	.global nbif_ccallemu3
-nbif_ccallemu3:
+	GLOBAL(ASYM(nbif_ccallemu3))
+ASYM(nbif_ccallemu3):
 	movl	ARG2, P_ARG2(P)
 #if X86_NR_ARG_REGS > 3
 	movl	ARG3, ARG2
@@ -156,8 +156,8 @@
 
 #if X86_NR_ARG_REGS >= 2
 	.align	4
-	.global nbif_ccallemu2
-nbif_ccallemu2:
+	GLOBAL(ASYM(nbif_ccallemu2))
+ASYM(nbif_ccallemu2):
 	movl	ARG1, P_ARG1(P)
 #if X86_NR_ARG_REGS > 2
 	movl	ARG2, ARG1
@@ -169,8 +169,8 @@
 
 #if X86_NR_ARG_REGS >= 1
 	.align	4
-	.global nbif_ccallemu1
-nbif_ccallemu1:
+	GLOBAL(ASYM(nbif_ccallemu1))
+ASYM(nbif_ccallemu1):
 	movl	ARG0, P_ARG0(P)
 #if X86_NR_ARG_REGS > 1
 	movl	ARG1, ARG0
@@ -181,8 +181,8 @@
 #endif
 
 	.align	4
-	.global nbif_ccallemu0
-nbif_ccallemu0:
+	GLOBAL(ASYM(nbif_ccallemu0))
+ASYM(nbif_ccallemu0):
 	/* We use %eax not ARG0 here because ARG0 is not
 	   defined when NR_ARG_REGS == 0. */
 #if X86_NR_ARG_REGS == 0
@@ -196,8 +196,8 @@
  * This is where native code suspends.
  */
 	.align	4
-	.global	nbif_suspend_0
-nbif_suspend_0:
+	GLOBAL(ASYM(nbif_suspend_0))
+ASYM(nbif_suspend_0):
 	movl	$HIPE_MODE_SWITCH_RES_SUSPEND, %eax
 	jmp	.suspend_exit
 
@@ -205,8 +205,8 @@
  * Suspend from a receive (waiting for a message)
  */
 	.align	4
-	.global	nbif_suspend_msg
-nbif_suspend_msg:
+	GLOBAL(ASYM(nbif_suspend_msg))
+ASYM(nbif_suspend_msg):
 	movl	$HIPE_MODE_SWITCH_RES_WAIT, %eax
 	jmp	.suspend_exit
 
@@ -216,8 +216,8 @@
  *	else { return 0; }
  */
 	.align	4
-	.global	nbif_suspend_msg_timeout
-nbif_suspend_msg_timeout:
+	GLOBAL(ASYM(nbif_suspend_msg_timeout))
+ASYM(nbif_suspend_msg_timeout):
 	movl	P_FLAGS(P), %eax
 	/* this relies on F_TIMO (1<<2) fitting in a byte */
 	testb	$F_TIMO, %al			# F_TIMO set?
@@ -234,8 +234,8 @@
  * Emulated code returns to its native code caller.
  */
 	.align	4
-	.global	x86_return_to_native
-x86_return_to_native:
+	GLOBAL(CSYM(x86_return_to_native))
+CSYM(x86_return_to_native):
 	ENTER_FROM_C
 	/* get return value */
 	movl	P_ARG0(P), %eax
@@ -251,8 +251,8 @@
  * Emulated code tailcalls native code.
  */
 	.align	4
-	.global	x86_tailcall_to_native
-x86_tailcall_to_native:
+	GLOBAL(CSYM(x86_tailcall_to_native))
+CSYM(x86_tailcall_to_native):
 	ENTER_FROM_C
 	/* get argument registers */
 	LOAD_ARG_REGS
@@ -264,8 +264,8 @@
  * Emulated code throws an exception to its native code caller.
  */
 	.align	4
-	.global	x86_throw_to_native
-x86_throw_to_native:
+	GLOBAL(CSYM(x86_throw_to_native))
+CSYM(x86_throw_to_native):
 	ENTER_FROM_C
 	/* invoke the handler */
 	jmp	*P_NCALLEE(P)		# set by hipe_find_handler()
@@ -274,8 +274,8 @@
  * This is the default exception handler for native code.
  */
 	.align	4
-	.global	nbif_fail
-nbif_fail:
+	GLOBAL(ASYM(nbif_fail))
+ASYM(nbif_fail):
 	movl	$HIPE_MODE_SWITCH_RES_THROW, %eax
 	jmp	.flush_exit
 	
@@ -284,9 +284,9 @@
  * exceptional condition, and RESCHEDULE cannot occur.
  * The stack/heap registers were just read from P.
  */
-	.global	nbif_1_simple_exception
-	.global	nbif_2_simple_exception
-	.global	nbif_3_simple_exception
+	GLOBAL(nbif_1_simple_exception)
+	GLOBAL(nbif_2_simple_exception)
+	GLOBAL(nbif_3_simple_exception)
 	.align	4
 nbif_1_simple_exception:
 	movl	$1, %eax
@@ -312,7 +312,7 @@
 	/* find and prepare to invoke the handler */
 	SWITCH_ERLANG_TO_C_QUICK	# The cached state is clean and need not be saved.
 	movl	P, (%esp)
-	call	hipe_handle_exception	# Note: hipe_handle_exception() conses
+	call	CSYM(hipe_handle_exception)	# Note: hipe_handle_exception() conses
 	SWITCH_C_TO_ERLANG		# %esp updated by hipe_find_handler()
 	/* now invoke the handler */
 	jmp	*P_NCALLEE(P)		# set by hipe_find_handler()
@@ -337,8 +337,8 @@
  * P_ARG0(P) is the first actual parameter, if X86_NR_ARG_REGS > 0.
  * P_ARG1(P) is the second actual parameter (if defined), if X86_NR_ARG_REGS > 1.
  */
-	.global	nbif_1_hairy_exception
-	.global	nbif_2_hairy_exception
+	GLOBAL(nbif_1_hairy_exception)
+	GLOBAL(nbif_2_hairy_exception)
 	.align	4
 nbif_1_hairy_exception:
 	movl	$1, %eax
@@ -367,15 +367,15 @@
  * nbif_stack_trap_ra: trap return address for maintaining
  * the gray/white stack boundary
  */
-	.global	nbif_stack_trap_ra
+	GLOBAL(ASYM(nbif_stack_trap_ra))
 	.align	4
-nbif_stack_trap_ra:			# a return address, not a function
+ASYM(nbif_stack_trap_ra):			# a return address, not a function
 	# This only handles a single return value.
 	# If we have more, we need to save them in the PCB.
 	movl	%eax, TEMP_RV		# save retval
 	SWITCH_ERLANG_TO_C_QUICK
 	movl	P, (%esp)
-	call	hipe_handle_stack_trap	# must not cons; preserves TEMP_RV
+	call	CSYM(hipe_handle_stack_trap)	# must not cons; preserves TEMP_RV
 	movl	%eax, %edx		# original RA
 	SWITCH_C_TO_ERLANG_QUICK
 	movl	TEMP_RV, %eax		# restore retval
@@ -385,14 +385,14 @@
  * nbif_inc_stack_0
  */
 	.align	4
-	.global	nbif_inc_stack_0
-nbif_inc_stack_0:
+	GLOBAL(ASYM(nbif_inc_stack_0))
+ASYM(nbif_inc_stack_0):
 	SWITCH_ERLANG_TO_C_QUICK
 	STORE_CALLER_SAVE
 	movl	P, (%esp)
 	# hipe_inc_nstack reads and writes NSP and NSP_LIMIT,
 	# but does not access HP or FCALLS (or the non-x86 NRA).
-	call	hipe_inc_nstack
+	call	CSYM(hipe_inc_nstack)
 	LOAD_CALLER_SAVE
 	SWITCH_C_TO_ERLANG_QUICK
 	NSP_RET0
diff -rN -u old-otp-0804-1/erts/emulator/hipe/hipe_x86_signal.c new-otp-0804/erts/emulator/hipe/hipe_x86_signal.c
--- old-otp-0804-1/erts/emulator/hipe/hipe_x86_signal.c	2006-08-22 23:25:17.000000000 +0100
+++ new-otp-0804/erts/emulator/hipe/hipe_x86_signal.c	2006-08-22 23:25:23.000000000 +0100
@@ -140,7 +140,12 @@
 #define INIT()	do { if( !init_done() ) do_init(); } while(0)
 #endif	/* glibc 2.1 */
 
-#if !defined(__GLIBC__)
+/* Is there no standard identifier for Darwin/MacOSX ? */
+#if defined(__APPLE__) && defined(__MACH__) && !defined(__DARWIN__)
+#define __DARWIN__ 1
+#endif
+
+#if !defined(__GLIBC__) && !defined(__DARWIN__)
 /*
  * Assume Solaris/x86 2.8.
  * There is a number of sigaction() procedures in libc:
@@ -176,6 +181,19 @@
 #define INIT()	do { if( !init_done() ) do_init(); } while(0)
 #endif	/* not glibc */
 
+#ifdef __DARWIN__
+
+static int (*__next_sigaction)(int, const struct sigaction*, struct sigaction*);
+static int (*__orig_sigaction)(int, const struct sigaction*, struct sigaction*);
+#define init_done()	(__next_sigaction != 0)
+/*#define INIT()	do_init();*/
+#define _NSIG NSIG
+#define INIT()	do { if( !init_done() ) do_init(); } while(0)
+
+static void do_init();
+
+#endif /* __DARWIN__ */
+
 /*
  * This is our wrapper for sigaction(). sigaction() can be called before
  * hipe_signal_init() has been executed, especially when threads support
@@ -199,6 +217,25 @@
     return __next_sigaction(signum, act, oldact);
 }
 
+#ifdef __DARWIN__
+
+#include "mach_override.h"
+#include <dlfcn.h>
+
+static void do_init(void)
+{
+	kern_return_t err = mach_override_ptr((void*)&sigaction, 
+		(void*)&my_sigaction, (void**)&__next_sigaction);
+
+	if (!err) 
+		return;
+		
+	perror("mach_override");
+	abort();
+}
+
+#endif /* __DARWIN__ */
+
 /*
  * This overrides the C library's core sigaction() procedure, catching
  * all its internal calls.
@@ -210,6 +247,7 @@
 }
 #endif
 
+#ifndef __DARWIN__
 /*
  * This catches the application's own sigaction() calls.
  */
@@ -217,6 +255,7 @@
 {
     return my_sigaction(signum, act, oldact);
 }
+#endif
 
 /*
  * Set alternate signal stack for the invoking thread.
diff -rN -u old-otp-0804-1/erts/emulator/sys/unix/sys_float.c new-otp-0804/erts/emulator/sys/unix/sys_float.c
--- old-otp-0804-1/erts/emulator/sys/unix/sys_float.c	2006-08-22 23:25:17.000000000 +0100
+++ new-otp-0804/erts/emulator/sys/unix/sys_float.c	2006-08-22 23:25:23.000000000 +0100
@@ -87,7 +87,7 @@
 }
 
 /* Is there no standard identifier for Darwin/MacOSX ? */
-#if defined(__ppc__) && defined(__APPLE__) && defined(__MACH__) && !defined(__DARWIN__)
+#if defined(__APPLE__) && defined(__MACH__) && !defined(__DARWIN__)
 #define __DARWIN__ 1
 #endif
 
@@ -109,7 +109,7 @@
     __asm__ __volatile__("ldmxcsr %0" : : "m"(mxcsr));
 }
 
-#if defined(__x86_64__)
+#if defined(__x86_64__) || defined(__DARWIN__)
 static inline int cpu_has_sse2(void) { return 1; }
 #else /* !__x86_64__ */
 /*
@@ -321,7 +321,14 @@
 
 #endif
 
-#if defined(__linux__) && (defined(__x86_64__) || defined(__i386__))
+#if (defined(__linux__) || defined(__DARWIN__)) && (defined(__x86_64__) || defined(__i386__))
+
+#ifdef __DARWIN__
+#include <ucontext.h>
+static void skip_sse2_insn(mcontext_t mc)
+{
+    unsigned char *pc0 = (unsigned char*)(mc->ss.eip);
+#else
 static void skip_sse2_insn(mcontext_t *mc)
 {
 #if defined(__x86_64__)
@@ -329,6 +336,7 @@
 #else
     unsigned char *pc0 = (unsigned char*)(mc->gregs[REG_EIP]);
 #endif
+#endif
     unsigned char *pc = pc0;
     unsigned int opcode;
     unsigned int nr_skip_bytes;
@@ -424,6 +432,8 @@
     /* Done. */
 #if defined(__x86_64__)
     mc->gregs[REG_RIP] = (long)pc;
+#elif defined(__DARWIN__)
+		mc->ss.eip = (long)pc;
 #else
     mc->gregs[REG_EIP] = (long)pc;
 #endif
@@ -481,6 +491,13 @@
     regs[PT_NIP] += 4;
     regs[PT_FPSCR] = 0x80|0x40|0x10;	/* VE, OE, ZE; not UE or XE */
 #endif
+#elif defined(__DARWIN__) && defined(__i386__)
+    mcontext_t mc = uc->uc_mcontext;
+	  if (mc->fs.fpu_mxcsr & 0x000F) {
+			mc->fs.fpu_mxcsr &= ~(0x003F|0x0680);
+			skip_sse2_insn(mc);
+		}
+  	*((unsigned short *)&mc->fs.fpu_fsw) &= ~0xFF;
 #elif defined(__DARWIN__)
     mcontext_t mc = uc->uc_mcontext;
     mc->ss.srr0 += 4;

